/*
 *	main.c
 *
 *	Vv[v
 *
 *	* Tue Dec 31 00:00:00 JST 2002 Naoyuki Sawa
 *	- 1st [XB
 */
#include "app.h"

unsigned char C384[] = { /* BGM1 */
#include "mus/c384.dat"
};
unsigned char C455[] = { /* BGM2 */
#include "mus/c455.dat"
};
unsigned char C543[] = { /* WARN */
#include "mus/c543.dat"
};
unsigned char C553[] = { /* ^Cg */
#include "mus/c553.dat"
};
unsigned char C555[] = { /* Jnt@t@[ */
#include "mus/c555.dat"
};

/****************************************************************************
 *	萔E^
 ****************************************************************************/

#define FPS		20			/* t[[g */
#define SEC(s)		((int)(FPS * (s)))	/* b->t[ϊ */

short SIN_TBL[256];	/* sine[u(0Ɓ360A8bit) */
short TAN_TBL[256 / 8];
#define SIN(d)		SIN_TBL[(d) & 255]
#define COS(d)		SIN((d) + 64)
#define XPI2		((int)(PI2  * (1 << 8)))
#define XPI		((int)(PI   * (1 << 8)))
#define XPI_2		((int)(PI_2 * (1 << 8)))

#define CENTER_X	(DISP_X / 2)		/* ʂ̒ */
#define CENTER_Y	(DISP_Y / 2)

#define LOOP_R		16			/* ΂̎̉]a[sNZ] */

#define JUEL_R		4			/* WG̔a[sNZ] */
#define JUEL_2R		(JUEL_R * 2)		/* WG̒a[sNZ] */

#define MAX_POS1	(2 << 16)		/* WG]ʒu̍ől */
#define MAX_POS2	((1 << 16) / 6)		/* WGʒȕl */
#define MAX_COLORS	6			/* WG̐F */
#define MAX_JUELS	64			/* WG̍ő吔 */

#define GUN_R		(JUEL_2R * 3 / 4)	/* C̉]a[sNZ] */
#define GUN_ACC		(1 << 8)		/* ]x */
#define MAX_GUN_SPD	(16 << 8)		/* ]x̍ől */

#define POS2_SPD	(MAX_POS2 / FPS)	/* pos2Xs[h */
#define BACK_SPD	((JUEL_R * 3 / 4) << 8)	/* WGރXs[h */
#define BACK_TIME	SEC(0.5)
#define SHOT_SPD	(JUEL_R << 8)		/* Vbgړx */

#define WARN_ZONE	(96 << 8)		/* x][ */
#define WARN_SLOW	3			/* x][ł̃Xs[hቺW */

#define CHAIN_TIMEOUT	SEC(0.25)		/* A^CAEgt[ */

#define JUEL_SPD	32			/* WGXs[hA8rbg */
#define JUEL_ACC	 2			/* Ƃ̉WA8rbg */

#define STAT_NORMAL	0
#define STAT_ERASE	1
#define STAT_MISS	2

typedef struct _JUEL {
	int color;	/* F(0`MAX_COLORS-1) */
	short join;	/* 0:ÕWGɂȂĂȂ/1:ÕWGɂȂĂ/2:Ń`FbNv */
	short stat;	/* (STAT_*) */
	int cnt;	/* ėpJE^ */
	int back_cnt;	/* ރJE^ */
	int pos1;	/* œ̃fbhC0AŊȌoʒu2()ƂāA16rbgŕ\ */
	int pos2;	/* ˂oWG̕ʒuB]Oɑ΂60(=256/6)`0(=0)A16rbg)Bʏ0 */
	int x, y;	/* pos1Apos2vZAWGS̎W[sNZ] */
} JUEL;

typedef struct _GI {
	int score;
	int colors;

	int chain;
	int chain_timeout;

	int gun_next;		/* ̃Vbg̐F */
	int gun_color;		/* ݂̃Vbg̐F */
	int gun_dir;		/* ˕ */
	int gun_spd;		/* ]x */
	int gun_r;		/* ˌ̏Aj[VJE^ */
	int gun_anm;		/* ˕KChAj[VJE^ */

	int shot_color;		/* ˂ꂽVbg̐F */
	int shot_dir;		/* ˂ꂽVbg̕ */
	int shot_t;		/* ˂ꂽVbg̈ړA8rbg(0:˂ĂȂ) */

	int juel_spd;		/* WG̐isx */
	int n_juels;		/* WG̐ */
	JUEL juels[MAX_JUELS];	/* WG(0:<->O:MAX_JUELS-1) */
} GI;

/****************************************************************************
 *	ϐ
 ****************************************************************************/

int errno;		/* WbCuŒ`ĂȂ̂ */

int now;		/* O[o^C} */
int joy;		/* pbh */
int joy_rep[4];		/* pbh㉺ẼI[gs[gJE^ */

int hiscore;
int colors_sel = 4;	/* 2`MAX_COLORS */
GI gi;

/****************************************************************************
 *	֐錾
 ****************************************************************************/

void app_init();
void app_exit();
void schedule();
int demo();
void game();
int ATN2(int y, int x);
int juel_gen(int force);
void juel_work();
void shot_work(int shot);
void erase_check();
void erase_work();
void chain_check();
void bg_disp();
int field_disp(int obj, int shot_disp);

/****************************************************************************
 *	smain
 ****************************************************************************/

void
smain()
{
	/* B */
	app_init();

	/* C[vB */
	for(;;) {
		if(demo() != 0) break;
		game();
	}

	/* N[AbvB
	 * START+SELECTŏIꍇ̓N[Abv͍s܂B
	 */
	app_exit();
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	int retval;
	int i;

	/* hFǂݍ݂܂B */
	thread_lock();
	retval = loadInst();
	thread_unlock();
	if(retval != 0) {
		grcls(3);
		symbol(4, 34, "drum.binǂݍݎsł", 0, 0);
		symbol(4, 44, "h͍Đ܂", 0, 0);
		wait(3000);
		grcls(-1);
	}

	/* \ݒB */
	dispmode(1,	/* 1:XvCg\/0:\ */
		 1,	/* 1:eLXg\/0:\ */
		 1,	/* 1:OtBbN\/0:\ */
		 1,	/* 1:eLXgO/0:w */
		 0);	/* wiF(wʕ\Ȃ̂) */

	/* V[hB */
	srand(msec());

	/* sine[u܂B */
	for(i = 0; i < 256; i++) {
		SIN_TBL[i] = (int)(sin(PI2 * i / 256) * (1 << 8));
	}

	/* tane[u܂B */
	for(i = 0; i < 32; i++) {
		TAN_TBL[i] = (int)(tan(PI2 * (i + 0.5) / 256) * (1 << 8));
	}
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
	static unsigned prev;
	       unsigned cur;
	int joy_old, trg, i;

	int pause;

	pause = 0;
	for(;;) {
		/* [VSYNC҂B */
		if(prev == 0) prev = msec();
		do {
			cur = msec();
		} while((cur - prev) * FPS < 1000); /* (cur-prev)<(1000/FPS)̕ό` */
		prev = cur;

		/* pbhԎ擾B
		 * VvCuł́AgKI[gs[g̔ōsȂ΂܂B
		 */
		joy_old = joy;
		joy = pad() & 0x00ff;
		trg = (joy ^ joy_old) & joy;
		joy |= trg << 8;
		for(i = 0; i < 4; i++) { /* ㉺E(bit0`3)̂݃I[gs[g */
			if(joy & 1 << i) { /* PAD_*ONȂ  */
				joy_rep[i]++;  /* JEgAbv */
				if(joy_rep[i] >= SEC(0.33) && joy_rep[i] & 1) { /* 莞ԉÂA2t[ */
					joy |= 1 << (i + 8); /* gK */
				}
			} else {
				joy_rep[i] = 0; /* JE^NA */
			}
		}

		/* PAUSEB */
		if(joy & TRG_START) {
			pause = !pause; /* PAUSEԐ؂ւ */
			if(!pause) pausedisp(0);
		}
		if(!pause) break;

		/* PAUSEbZ[W_ŕ\B */
		if(msec() % 1000 < 750) {
			pausedisp(1);
		} else {
			pausedisp(0);
		}
	}
	now++;	/* O[o^C}XV */
}

/****************************************************************************
 *	demo
 ****************************************************************************/

int
demo()
{
	int result;

	pmdplay(C553);

	/* ʃNAB */
	bgcls();
	grcls(-1);
	spcls(0);

	/* ^Cg\B */
	locate(5, 4); printstr("SIMPLE");
	locate(5, 5); printstr(" LOOP ");

	/* XRA\B */
	locate(0, 0); printstr("HISCORE");
	locate(0, 1); siprintf("%07d", hiscore  <= 9999999 ? hiscore  : 9999999);
	locate(9, 0); printstr("1PSCORE");
	locate(9, 1); siprintf("%07d", gi.score <= 9999999 ? gi.score : 9999999);

	for(;;) {
		schedule();

		/* Q[JnA܂͏IH */
		if(joy & TRG_A     ) { result =  0; pmdplay(C555); break; }
		if(joy & TRG_SELECT) { result = -1; pmdstop();     break; }

		/* FIB */
		if(joy & TRG_LF && 2 < colors_sel             ) { colors_sel--; sound(3); }
		if(joy & TRG_RI &&     colors_sel < MAX_COLORS) { colors_sel++; sound(3); }
		locate(4, 7); siprintf("%d COLORS", colors_sel);

		/* vvg\B */
		locate(3,  9); printstr(now % SEC(0.75) < SEC(0.5) ? "[ A ] START" : "           ");
		locate(3, 10); printstr(now % SEC(0.75) < SEC(0.5) ? "[SEL] EXIT " : "           ");
	}
	sound(0);

	return result;
}

/****************************************************************************
 *	game
 ****************************************************************************/

void
game()
{
	static int bgm_sel;
	unsigned char* bgm;
	int obj, i, j, spd, pos1, bgm_mode;
	
	memset(&gi, 0, sizeof gi);
	gi.colors = colors_sel;
	gi.juel_spd = JUEL_SPD; /* Xs[h */

	/* BGMIB */
	if(bgm_sel++ & 1) {
		bgm = C384;
	} else {
		bgm = C455;
	}

	/* ʃNAB */
	bgcls();
	grcls(-1);
	spcls(0);

	locate(4, 5); printstr(" READY? ");

	/* wǐŒ蕔`B */
	bg_disp();

	locate(4, 5); printstr("  G O ! ");

	/* WGA1/2oB */
	do {
		schedule();
		juel_gen(1);
		shot_work(0);
		juel_work();
		obj = 0;
		obj = field_disp(0, 1);
		spcls(obj);
	} while(gi.juels[0].pos1 > MAX_POS1 - (1 << 15));

	locate(4, 5); printstr("        ");

	/* Q[[vB */
	bgm_mode = 0;
	pmdplay(bgm);
	for(;;) {
		schedule();

		/* WGis^Q[I[o[B */
		spd = gi.juel_spd;
		if(gi.n_juels) {
			pos1 = gi.juels[0].pos1;
			if(pos1 <= 0) break; /* GAMEOVER */
			if(pos1 < WARN_ZONE) {
				spd /= WARN_SLOW; /* x][X[_E */
				if(bgm_mode == 0) {
					pmdplay(C543);
					bgm_mode = 1;
				}
			} else {
				if(bgm_mode == 1) {
					pmdplay(bgm);
					bgm_mode = 0;
				}
			}
			gi.juels[gi.n_juels - 1].pos1 -= spd;
		}

		/* e폈B */
		juel_gen(0);
		shot_work(1);
		erase_check();
		erase_work();
		chain_check();
		juel_work();

		/* \B */
		obj = 0;
		obj = field_disp(obj, 1);
		spcls(obj);
	}
	pmdstop();

	/* WGΉEŁB */
	for(i = 0; i < gi.n_juels; i++) {
		schedule();
		gi.gun_dir -= (1 << 16) / SEC(0.25);
		for(j = 0; j < i - 1; j++) {
			gi.juels[j].cnt++;
			if(gi.juels[j].cnt < SEC(2)) sound(1);
		}
		gi.juels[i].stat = STAT_MISS;
		gi.juels[i].cnt = 0;
		obj = 0;
		obj = field_disp(obj, 0);
		spcls(obj);
	}
	locate(4, 5); printstr("GAMEOVER");
	for(i = 0; i < SEC(5); i++) {
		schedule();
		gi.gun_dir -= (1 << 16) / SEC(0.25);
		for(j = 0; j < gi.n_juels; j++) {
			gi.juels[j].cnt++;
			if(gi.juels[j].cnt < SEC(2)) sound(1);
		}
		obj = 0;
		obj = field_disp(obj, 0);
		spcls(obj);
		if(joy & (TRG_A | TRG_B)) break; /* LZ */
	}

	/* nCXRAXVB */
	if(gi.score > hiscore) hiscore = gi.score;
}

/****************************************************************************
 *	ATN2
 ****************************************************************************/

int
ATN2(int y, int x)
{
	int i, t, area;

	if(x == 0 && y == 0) return 0;

	if(y >= 0) {
		if(x >= 0) {
			if(x >= y) { /* 0`45 */
				area = 0;
				t = (y << 8) / x;
			} else { /* 45`90 */
				area = 1;
				t = (x << 8) / y;
			}
		} else {
			x = -x;
			if(x >= y) { /* 180`135 */
				area = 3;
				t = (y << 8) / x;
			} else { /* 135`90 */
				area = 2;
				t = (x << 8) / y;
			}
		}
	} else {
		y = -y;
		if(x >= 0) {
			if(x >= y) { /* -0`-45 */
				area = 4;
				t = (y << 8) / x;
			} else { /* -45`-90 */
				area = 5;
				t = (x << 8) / y;
			}
		} else {
			x = -x;
			if(x >= y) { /* -180`-135 */
				area = 7;
				t = (y << 8) / x;
			} else { /* -135`-90 */
				area = 6;
				t = (x << 8) / y;
			}
		}
	}

	/* oCiT[`ɕύX */
	for(i = 0; i < 32; i++) {
		if(t < TAN_TBL[i]) break;
	}

	switch(area) {
	case 0: i =    0 + i; break;
	case 1: i =   64 - i; break;
	case 2: i =   64 + i; break;
	case 3: i =  128 - i; break;
	case 4: i =    0 - i; break;
	case 5: i =  -64 + i; break;
	case 6: i =  -64 - i; break;
	case 7: i = -128 + i; break;
	}

	return i;
}

/****************************************************************************
 *	juel_gen
 ****************************************************************************/

/* juel_gen()juel_work()field_disp() Ƃ邱ƁB
 * juel_work()juel_gen()field_disp() ł͈ʒuXVȂ̂ŕsI
 */
int
juel_gen(int force)
{
	JUEL* juel;
	int pos1, ofs, r;

	if(gi.n_juels == MAX_JUELS) return 0; /* 󂫃GgȂ */

	/* ̃WG̈ʒuȉɂȂÃWGo\H
	 * i萔łAvẐ#defineɂ̂܂j
	 */
	pos1 = MAX_POS1;
	r = (pos1 + (1 << 16)) * LOOP_R >> 8;
	//   ~~~~.16 ~~~~~~~.16
	//  ~~~~~~~~~~~~~~~~~.16
	//  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~.8
	ofs = (JUEL_2R << 24) / (r * XPI2 >> 8);
	//    ~~~~~~~~~~~~~~~.24
	//                      ~~~~~~~~~~~~~~~.8
	//    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~.16
	pos1 -= ofs;

	if(force || gi.n_juels == 0) goto L10; /* oÃWGȂȂAʒuȂ */
	if(gi.juels[gi.n_juels - 1].pos1 > pos1) return 0; /* ̈ʒuɏo]TȂ */
L10:
	/* WGт̖ɁAVKWG܂B */
	juel = &gi.juels[gi.n_juels++];
	memset(juel, 0, sizeof(JUEL));
	juel->color = rnd(gi.colors);
	juel->pos1 = MAX_POS1;

	/* ołȂ悤ɁAŏ炭ĂB */
	if(gi.n_juels >= 2) {
		juel = &gi.juels[gi.n_juels - 2];
		if(juel->stat == STAT_NORMAL) juel->join = 1;
	}

	return 1;
}

/****************************************************************************
 *	juel_work
 ****************************************************************************/

/*  */
static void
juel_work_sub1()
{
	JUEL *juel1, *juel2;
	int i, j, pos1, pos2, ofs, r;

	/* WGт𑖍... */
	for(i = 0; i < gi.n_juels - 1/*܂Ō̂Ŗ͑Ȃ*/; i++) {
		juel1 = &gi.juels[i];
		if(juel1->stat != STAT_NORMAL) continue;	/* ʏԂŁA */
		if(juel1->join) continue;			/* ̃WGƂ̊Ԃɋ󂫂A */
		if(juel1->color != (juel1 + 1)->color) continue;/* FȂ... */
		juel1->back_cnt = BACK_TIME;			/* ߌގԂ */
	}

	/* WGт𑖍... */
	for(i = 0; i < gi.n_juels - 1/*܂Ō̂Ŗ͑Ȃ*/; i++) {
		juel1 = &gi.juels[i];
		if(juel1->back_cnt) {
			/* ރ}[NĂWGށB */
			pos1 = juel1->pos1;
			pos2 = juel1->pos2;
			r = (pos1 + (1 << 16)) * LOOP_R >> 8;
			ofs = ((BACK_SPD * juel1->back_cnt / BACK_TIME) << 16) / (r * XPI2 >> 8);
			pos1 += ofs;
			juel1->pos1 = pos1;
			ofs = (JUEL_2R * (COS(pos2 >> 8) - (1 << 7)) << 16) / (r * XPI2 >> 8);
			pos1 -= ofs; /* ރ}[NĂWG̐[WB */
			if(pos1 < 0) pos1 = 0;
			/* ւȂĂWG߂B */
			for(j = i - 1; j >= 0; j--) {
				juel2 = &gi.juels[j];
				//if(juel2->stat != STAT_NORMAL) break;
				if(!juel2->join) break;
				pos2 = juel2->pos2;
				r = (pos1 + (1 << 16)) * LOOP_R >> 8;
				ofs = (JUEL_2R * (COS(pos2 >> 8) - (1 << 7)) << 16) / (r * XPI2 >> 8);
				pos1 -= ofs;
				if(pos1 < 0) pos1 = 0;
				juel2->pos1 = pos1;
				r = (pos1 + (1 << 16)) * LOOP_R >> 8;
				ofs = (JUEL_2R * (COS(pos2 >> 8) - (1 << 7)) << 16) / (r * XPI2 >> 8);
				pos1 -= ofs;
				if(pos1 < 0) pos1 = 0;
			}
			/* OɃWGԂB */
			pos1 = juel1->pos1;
			pos2 = juel1->pos2;
			r = (pos1 + (1 << 16)) * LOOP_R >> 8;
			ofs = (JUEL_2R * (COS(pos2 >> 8) - (1 << 7)) << 16) / (r * XPI2 >> 8);
			pos1 += ofs; /* ރ}[NĂWG̖WB */
			for(j = i + 1; j < gi.n_juels; j++) {
				juel2 = &gi.juels[j];
				pos2 = juel2->pos2;
				r = (pos1 + (1 << 16)) * LOOP_R >> 8;
				ofs = (JUEL_2R * (COS(pos2 >> 8) - (1 << 7)) << 16) / (r * XPI2 >> 8);
				pos1 += ofs;
				if(juel2->pos1 >= pos1) break; /* 󔒂Ȃ牟߂܂ */
				if(!juel1->join) {
					juel1->join = 2; /* Ԃ牟߂IiރWGȊOłԂ邱Ƃ͂肦Ȃj */
					sound(3);
				}
				juel2->pos1 = pos1;
				r = (pos1 + (1 << 16)) * LOOP_R >> 8;
				ofs = (JUEL_2R * (COS(pos2 >> 8) - (1 << 7)) << 16) / (r * XPI2 >> 8);
				pos1 += ofs;
			}
			juel1->back_cnt--;
		}
	}
}

/* Oi */
static void
juel_work_sub2()
{
	JUEL* juel;
	int i, pos1, pos2, ofs, r, d, x, y;

	/* WGт𑖍...i납牟̂ŋtɑIj */
	pos1 = MAX_POS1 * 2; /* ̃WGňʒu␳Ȃ悤 */
	for(i = gi.n_juels - 1; i >= 0; i--) {
		juel = &gi.juels[i];

		/* ݂̃WĜWB */
		pos2 = juel->pos2;
		if(juel->stat == STAT_NORMAL && pos2 > 0) {
			pos2 -= POS2_SPD;
			if(pos2 < 0) pos2 = 0;
			juel->pos2 = pos2;
		}

		/* ÕWG̐[ł̌]aB */
		r = (pos1 + (1 << 16)) * LOOP_R >> 8;
		//   ~~~~.16 ~~~~~~~.16
		//  ~~~~~~~~~~~~~~~~~.16
		//  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~.8

		/* ÕWG̐[ʒu猻݂̃WG̒Sʒuւ̃ItZbgB */
		ofs = (JUEL_2R * (COS(pos2 >> 8) - (1 << 7)) << 16) / (r * XPI2 >> 8);
		//               ~~~~~~~~~~~~~~~~~~~~~~~~~~~.8
		//    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~.24
		//                                                    ~~~~~~~~~~~~~~~.8
		//    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~.16

		/* ݂̃WG̒Sʒu␳B */
		pos1 -= ofs;
		if(pos1 < 0) pos1 = 0;
		if(juel->pos1 > pos1) {
			juel->pos1 = pos1;
			if(!juel->join) {
				juel->join = 2; /* Ń`FbNv */
				sound(3);
			}
		} else {
			pos1 = juel->pos1;
		}

		/* ݂̃WG̒Sʒuł̌]aB */
		r = (pos1 + (1 << 16)) * LOOP_R >> 8;
		//   ~~~~.16 ~~~~~~~.16
		//  ~~~~~~~~~~~~~~~~~.16
		//  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~.8

		/* ݂̃WG̒Sʒu猻݂̃WG̐[ʒuւ̃ItZbgB */
		ofs = (JUEL_2R * (COS(pos2 >> 8) - (1 << 7)) << 16) / (r * XPI2 >> 8);
		//               ~~~~~~~~~~~~~~~~~~~~~~~~~~~.8
		//    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~.24
		//                                                    ~~~~~~~~~~~~~~~.8
		//    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~.16

		/* ݂̃WĜԂɂ锼a␳B */
		r -= JUEL_2R * SIN(pos2 >> 8);

		/* ݂̃WG̍Wi[B */
		d = 192 - (pos1 >> 8);
		x = CENTER_X + (COS(d) * r >> 16);
		//              ~~~~~~.8 ~.8
		//              ~~~~~~~~~~.16
		//             ~~~~~~~~~~~~~~~~~~.0
		y = CENTER_Y + (SIN(d) * r >> 16);
		//              ~~~~~~.8 ~.8
		//              ~~~~~~~~~~.16
		//             ~~~~~~~~~~~~~~~~~~.0
		juel->x = x;
		juel->y = y;

		/* ݂̃WG̐[WB */
		pos1 -= ofs;
		if(pos1 < 0) pos1 = 0;
	}
}

void
juel_work()
{
	juel_work_sub1(); /* ł͍Wݒ肵Ȃ̂ŕKɁI */
	juel_work_sub2();
}

/****************************************************************************
 *	shot_work
 ****************************************************************************/

/* shot_work()juel_work()field_disp() Ƃ邱ƁB
 * juel_work()shot_work()field_disp() ł͓WG̈ʒuXVȂ̂ŕsI
 */
void
shot_work(int shot)
{
	JUEL* juel;
	int i, d, r, x, y, dx, dy, i_near, d_near, pos1, ofs;

	/* C̉]B */
	if(joy & PAD_LF) {
		/* ]B */
		gi.gun_spd += GUN_ACC;
		if(gi.gun_spd > MAX_GUN_SPD) gi.gun_spd = MAX_GUN_SPD;
		/* ]B */
		gi.gun_dir += gi.gun_spd;
		while(gi.gun_dir >= 128 << 8) gi.gun_dir -= 256 << 8;
	} else if(joy & PAD_RI) {
		/* ]B */
		gi.gun_spd += GUN_ACC;
		if(gi.gun_spd > MAX_GUN_SPD) gi.gun_spd = MAX_GUN_SPD;
		/* ]B */
		gi.gun_dir -= gi.gun_spd;
		while(gi.gun_dir < -128 << 8) gi.gun_dir += 256 << 8;
	} else {
		gi.gun_spd = 0;
	}
	gi.gun_anm++;

	/* ˁH */
	if(shot) {
		if(!gi.shot_t && (joy & (TRG_A | TRG_B))) {
			sound(0);
			/* VbgˁB */
			gi.shot_color = gi.gun_color;
			gi.shot_dir = gi.gun_dir;
			gi.shot_t = GUN_R << 8;
			/* ̃Vbg̏B */
			gi.gun_color = gi.gun_next;
			gi.gun_next = rnd(gi.colors);
			gi.gun_r = 0;
		}
	}
	if(gi.gun_r < GUN_R) gi.gun_r++;

	/* VbgړB */
	if(gi.shot_t) {
		gi.shot_t += SHOT_SPD;
		d = 192 - (gi.shot_dir >> 8);
		x = CENTER_X + (COS(d) * gi.shot_t >> 16);
		y = CENTER_Y + (SIN(d) * gi.shot_t >> 16);
		if(x < 0 - JUEL_R || DISP_X + JUEL_R < x ||
		   y < 0 - JUEL_R || DISP_Y + JUEL_R < y) {
			gi.shot_t = 0;
			goto L10;
		}
		/* 蔻B */
		i_near = -1;
		d_near = 0; /* x} */
		for(i = 0; i < gi.n_juels; i++) {
			juel = &gi.juels[i];
			if(juel->stat != STAT_NORMAL) continue;
			dx = juel->x - x;
			if(abs(dx) > JUEL_2R) continue;
			dy = juel->y - y;
			if(abs(dy) > JUEL_2R) continue;
			d = dx * dx + dy * dy;
			if(d > JUEL_2R * JUEL_2R) continue;
			if(i_near == -1 || d < d_near) {
				i_near = i;
				d_near = d;
			}
		}
		if(i_near == MAX_JUELS - 1) goto L10; /* ŏIGgɂ͓Ă܂(̉ʓ|) */
		if(i_near == -1) goto L10;

		/* WGVWGւ̈ʒuɋ߂Ă܂B */
		juel = &gi.juels[i_near];
		pos1 = juel->pos1;
		r = (pos1 + (1 << 16)) * LOOP_R >> 8;
		ofs = (JUEL_R << 24) / (r * XPI2 >> 8);

		/* WǦɓHɓH */
		d = (char)((gi.shot_dir >> 8) - (juel->pos1 >> 8));
		if(d <= 0) { /* ɓ */
			/* VWGꏊ󂯂܂B */
			if(gi.n_juels == MAX_JUELS) gi.n_juels--;
			memmove(juel + 1, juel, sizeof(JUEL) * (gi.n_juels - i_near));
			gi.n_juels++;
			/* VWG̉B */
			memset(juel, 0, sizeof(JUEL));
			juel->color = gi.shot_color;
			juel->pos1 = pos1 - ofs;
			if(juel->pos1 < 0) juel->pos1 = 0;
			juel->pos2 = MAX_POS2;
			/* ݒB */
			juel->join = 2;
		} else { /* ɓ */
			/* VWGꏊ󂯂܂B */
			i_near++; /* ŏIGgɂ͓ĂȂ̂ŁA+1ĂMAX_JUELS-1𒴂邱Ƃ͂܂ */
			juel++;
			if(gi.n_juels == MAX_JUELS) gi.n_juels--;
			memmove(juel + 1, juel, sizeof(JUEL) * (gi.n_juels - i_near));
			gi.n_juels++;
			/* VWG̉B */
			memset(juel, 0, sizeof(JUEL));
			juel->color = gi.shot_color;
			juel->pos1 = pos1 + ofs;
			juel->pos2 = MAX_POS2;
			/* ݒB */
			if((juel - 1)->join) juel->join = 2;
			if((juel - 1)->color == juel->color) {
				(juel - 1)->join = 2;
			} else {
				(juel - 1)->join = 1;
			}
		}
		sound(3);

		/* Vbg܂B */
		gi.shot_t = 0;
	}
L10:
}

/****************************************************************************
 *	erase_check
 ****************************************************************************/

void
erase_check()
{
	JUEL *juel1, *juel2;
	int i, j, color, cnt, check;

	/* WGO֑... */
	for(i = 0; i < gi.n_juels; i++) {
		juel1 = &gi.juels[i];
		if(juel1->stat != STAT_NORMAL) continue;	/* ɏŒȂ΂ */
		if(!juel1->join) continue;			/* ̃WGɂȂĂȂΔ΂ */
		color = juel1->color;				/* Ȃ𒲂ׂJ[ */
		cnt = 1;					/* n_̕JEg */
		check = juel1->join == 2;			/* Ȃ̒Ɉȏ`FbN}[N邩H */
		for(j = i + 1; j < gi.n_juels; j++) {		/* ̃WG瑖... */
			juel2 = &gi.juels[j];
			if(juel2->stat != STAT_NORMAL) continue;/* ɏŒȂ΂ */
			if(juel2->color != color) break;	/* F璆f */
			cnt++;					/* ȂJEgAbv */
			if(!juel2->join) break;			/* ̃WGɂȂĂȂ΂܂ */
			if(juel2->join == 2) check = 1;		/* Ȃ̒Ɉȏ`FbN}[N邩H */
		}
		if(cnt < 3) continue;				/* Ȃ肪OȉȂ΂ */
		if(!check) continue;				/* Ȃ̒Ƀ`FbN}[NȂΔ΂ */
		for(j = 0; j < cnt; j++) {			/* Ń}[N */
			juel2 = &gi.juels[i + j];
			juel2->stat = STAT_ERASE;
			juel2->cnt = 0;
		}
		gi.chain++;				/* AJEgAbv */
		gi.score += gi.chain * cnt * 10;	/* |CgA~Ȃ萔~10_ */
		gi.juel_spd += JUEL_ACC;		/*  */
		sound(1);
	}

	/* SĂ̏Ń`FbNv낵܂B */
	for(i = 0; i < gi.n_juels; i++) {
		juel1 = &gi.juels[i];
		if(juel1->join == 2) juel1->join = 1;
	}
}

/****************************************************************************
 *	erase_work
 ****************************************************************************/

void
erase_work()
{
	JUEL* juel;
	int i;

	/* WGт𑖍...îŋtɑIj */
	for(i = gi.n_juels - 1; i >= 0; i--) {
		juel = &gi.juels[i];
		if(juel->stat != STAT_ERASE) continue; /* ŒȊÕWG͔΂ */
		/* ŃJE^𑝂₵A^CAEgȂ܂B */
		juel->cnt++;
		if(juel->cnt >= SEC(1)) {
			memmove(juel, juel + 1, sizeof(JUEL) * (gi.n_juels - i));
			gi.n_juels--;
			if(i > 0) (juel - 1)->join = 0; /* ̃WGւ̂Ȃmɉ */
		}
	}
}

/****************************************************************************
 *	chain_check
 ****************************************************************************/

void
chain_check()
{
	JUEL* juel;
	int i;

	/* ŃWGރWGȂԂ莞ԑAAB */
	for(i = 0; i < gi.n_juels; i++) {
		juel = &gi.juels[i];
		if(juel->stat == STAT_ERASE || juel->back_cnt) {
			gi.chain_timeout = 0;
			return;
		}
	}
	if(gi.chain_timeout < CHAIN_TIMEOUT) gi.chain_timeout++;
	if(gi.chain_timeout >= CHAIN_TIMEOUT) gi.chain = 0;
}

/****************************************************************************
 *	bg_disp
 ****************************************************************************/

void
bg_disp()
{
	int color, pos, ofs, r, d, x1, y1, x2, y2;

	/* [\B */
	color = 1;
	pos = MAX_POS1;
	r = (pos + (1 << 16)) * LOOP_R >> 8;
	d = 192 - (pos >> 8);
	x2 = CENTER_X + (COS(d) * r >> 16);
	y2 = CENTER_Y + (SIN(d) * r >> 16);
	ofs = (JUEL_2R << 16) / (r * XPI2 >> 8);
	do {
		if(pos < WARN_ZONE) color = 3;
		x1 = x2;
		y1 = y2;
		pos -= ofs;
		if(pos < 0) pos = 0;
		r = (pos + (1 << 16)) * LOOP_R >> 8;
		d = 192 - (pos >> 8);
		x2 = CENTER_X + (COS(d) * r >> 16);
		y2 = CENTER_Y + (SIN(d) * r >> 16);
		line(x1, y1, x2, y2, color);
		ofs = (JUEL_2R << 16) / (r * XPI2 >> 8);
	} while(pos > 0);
}

/****************************************************************************
 *	field_disp
 ****************************************************************************/

int
field_disp(int obj, int shot_disp)
{
	JUEL* juel;
	int i, d, r, x, y, pat, color;

	/* ̃VbgB */
	x = CENTER_X;
	y = CENTER_Y;
	if(gi.gun_r == GUN_R) {
		pat = 0xa0 + gi.gun_next;
	} else if(gi.gun_r >= GUN_R - 4) {
		pat = 0x80 + (gi.gun_r - (GUN_R - 4));
	} else {
		pat = 0;
	}
	if(pat) spdisp(obj++, x - 4, y - 4, pat);

	/* CB */
	d = 192 - (gi.gun_dir >> 8);
	x = CENTER_X + (COS(d) * gi.gun_r >> 8);
	y = CENTER_Y + (SIN(d) * gi.gun_r >> 8);
	pat = 0x90 + gi.gun_color;
	spdisp(obj++, x - 4, y - 4, pat);

	/* WGсB */
	for(i = 0; i < gi.n_juels; i++) {
		juel = &gi.juels[i];
		if(juel->pos1 > MAX_POS1) continue; /* ߂ꂷWǴA݂͎c邯Ǖ\Ȃ */
		x = juel->x;
		y = juel->y;
		switch(juel->stat) {
		case STAT_NORMAL:
			pat = 0x90 + juel->color;
			break;
		case STAT_ERASE:
			if(juel->cnt < SEC(1) - 4 * 2) {
				if(juel->cnt & 1) {
					pat = 0x90 + juel->color;
				} else {
					pat = 0xb0 + juel->color;
				}
			} else if(juel->cnt < SEC(1)) {
				pat = 0x80 + (3 - (juel->cnt - (SEC(1) - 4 * 2)) / 2);
			} else {
				pat = 0;
			}
			break;
		case STAT_MISS:
			if(juel->cnt < SEC(2)) {
				pat = 0x80 + 5;
			} else if(juel->cnt < SEC(2) + 4 * 2) {
				pat = 0x80 + (3 - (juel->cnt - SEC(2)) / 2);
			} else {
				pat = 0;
			}
			break;
		default:
			DIE();
		}
		if(pat != 0) spdisp(obj++, x - 4, y - 4, pat);
	}

	if(shot_disp) {
		/* VbgB */
		if(gi.shot_t) {
			gi.shot_t += SHOT_SPD;
			d = 192 - (gi.shot_dir >> 8);
			x = CENTER_X + (COS(d) * gi.shot_t >> 16);
			y = CENTER_Y + (SIN(d) * gi.shot_t >> 16);
			pat = 0x90 + gi.shot_color;
			spdisp(obj++, x - 4, y - 4, pat);
		}

		/* ˕KChB */
		r = (GUN_R + JUEL_R) + (gi.gun_anm & 15);
		pat = 0x80 + 4;
		for(;;) {
			d = 192 - (gi.gun_dir >> 8);
			x = CENTER_X + (COS(d) * r >> 8);
			y = CENTER_Y + (SIN(d) * r >> 8);
			if(x < 0 - JUEL_R || DISP_X + JUEL_R < x ||
			   y < 0 - JUEL_R || DISP_Y + JUEL_R < y) break;
			spdisp(obj++, x - 4, y - 4, pat);
			r += 16;
		}
	}

	/* WGx][ɂAfbhC_ŁB */
	color = 3;
	if(gi.n_juels && gi.juels[0].pos1 < WARN_ZONE && (now & 1)) color = 0;
	fill(CENTER_X - 1, CENTER_Y - LOOP_R - JUEL_R, CENTER_X, CENTER_Y, color);

	/* _ȂǕ\B */
	locate(0, 0); siprintf("%07d", gi.score <= 9999999 ? gi.score : 9999999);
	locate(0, 1);
	if(gi.chain > 1) {
		siprintf("CHAIN%2d", gi.chain);
	} else {
		siprintf("       ");
	}

	return obj;
}


